const Main = imports.ui.main;
const Meta = imports.gi.Meta;
const Util = imports.misc.util;
const GLib = imports.gi.GLib;

let workspaceSwitchedId;

function init() {
    // do nothing
}

function enable() {
    // connect to the 'workspace-switched' signal of the global screen object
    // Connect to the workspace-switched signal
    global.workspace_manager.connect('workspace-switched', this._checkRunningApplications);
    log(`WorkspaceFocus enabled`)
}

function disable() {
    // disconnect from the 'workspace-switched' signal
    global.workspace_manager.disconnect(this._checkRunningApplications);
    log(`WorkspaceFocus disabled`)

}


function _setFocus() {
    let workspace = global.workspace_manager.get_active_workspace();
    let windows = workspace.list_windows();
    let mostRecentWindow = null;
    let mostRecentTime = 0;

    /*
    for (let i = 0; i < windows.length; i++) {
        let window = windows[i];
        let lastTimeFocused = window.get_user_time();
            
        //if (lastTimeFocused > mostRecentTime && !window.minimized && !isWindowInNonWorkspace) {
        if (lastTimeFocused > mostRecentTime && !window.minimized && window.window_type !== 'desktop') {
            mostRecentWindow = window;
            mostRecentTime = lastTimeFocused;
        }
        if (window.minimized) {
            //log(`Minimized window ID: ${window.get_id()}, ${window.get_user_time()}`);
        }
    }
    */
    let display = global.display;
    //let property = display.get_xatom("_NET_CLIENT_LIST_STACKING");
    //let windowList2 = display.get_x_property(property, "WINDOW", 0, -1, false);
    let windowList2 = display.sort_windows_by_stacking(windows);
    for (let i = windowList2.length - 1; i >= 0; i--) {
        win = windowList2[i];
        if (win.minimized || isWindowInNonWorkspace(win)) {
            continue;
        }
        if (windows.includes(win)) {
            let windowTitle = "";
            // Get the window actor for the given window
            const windowActor = global.get_window_actors().find(actor => actor.metaWindow === win);
    
            if (windowActor) {
                // Get the window title from the window actor
                windowTitle = windowActor.get_meta_window().get_title();
            }
            log(`Most recent window: [${workspace.index()}] ${win.get_id()} - ${windowTitle}`);
            //win.activate(global.get_current_time());
            delayFunction(() => (win.activate(global.get_current_time())), 100);
            //win.activate_with_workspace(global.get_current_time(), workspace);
            //win.focus(global.get_current_time());
            break;
        }
    }

    /*
    if (mostRecentWindow) {
        let windowTitle = "";
        // Get the window actor for the given window
        const windowActor = global.get_window_actors().find(actor => actor.metaWindow === mostRecentWindow);

        if (windowActor) {
            // Get the window title from the window actor
            windowTitle = windowActor.get_meta_window().get_title();
        }
        log(`Most recent window ID: [${workspace.index()}] ${mostRecentWindow.get_id()} - ${windowTitle}`);
        mostRecentWindow.activate(global.get_current_time());
    }
    */
}


function isWindowInNonWorkspace(window) {
    let ret = window.is_on_all_workspaces();
    if (ret) {
        let workspace = window.get_workspace();
        let windowTitle = "";
        // Get the window actor for the given window
        const windowActor = global.get_window_actors().find(actor => actor.metaWindow === window);

        if (windowActor) {
            // Get the window title from the window actor
            windowTitle = windowActor.get_meta_window().get_title();
        }
        log(`isWindowInNonWorkspace() is true for [${workspace.index()}] ${window.get_id()} - ${windowTitle}`);
    }
    return ret;
    /*
    const workspaceManager = Main.workspaceManager;
    const workspace = workspaceManager.get_workspace_by_index(-1);
    const windowList = workspace.list_windows();

    let tmp_ws = window.get_workspace();
    if (tmp_ws.index() == -1) {
        return true;
    }
    if (windowList.includes(window)) {
      //return workspace;
      return true;
    }
    return false;
    */
}

function delayFunction(callback, delay) {
    GLib.timeout_add(GLib.PRIORITY_DEFAULT, delay, callback);
}